#ifndef UNIVERSAL_CHARACTER_TEST_HH
#define UNIVERSAL_CHARACTER_TEST_HH

#include <cppunit/extensions/HelperMacros.h>
#include "VHDLDataTest.hh"

class UniversalCharacter;

class UniversalCharacterTest : public VHDLDataTest {
  CPPUNIT_TEST_SUITE( UniversalCharacterTest);
  CPPUNIT_TEST(testGetUniversalKind);
  CPPUNIT_TEST(testGetLength);
  CPPUNIT_TEST(testPrint);
  CPPUNIT_TEST(testEqual);
  CPPUNIT_TEST(testNotEqual);
  CPPUNIT_TEST(testGreater);
  CPPUNIT_TEST(testGreaterEqual);
  CPPUNIT_TEST(testLess);
  CPPUNIT_TEST(testLessEqual);
  CPPUNIT_TEST(testClone);
  CPPUNIT_TEST(testSerialization);
  CPPUNIT_TEST_SUITE_END();

private:
  UniversalCharacter *toTest;

  static char getDefaultValue();

public:
  void setUp();
  void tearDown();

  void testGetUniversalKind();
  void testGetLength();
  void testPrint();
  void testEqual();
  void testNotEqual();
  void testGreater();
  void testGreaterEqual();
  void testLess();
  void testLessEqual();
  void testClone();
  void testSerialization();
};

#endif
